//
//  WTDDataModel_v1.h
//  What ToDo
//
//  Created by Devin Coughlin on 5/11/06.
//  Copyright 2006 Objective Satisfaction. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#import "DCManagedObject_v1.h"

@class WTDToDoItem_v1;
@class WTDContext_v1;

@interface WTDDataModel_v1 : DCManagedObject_v1 {

}


/* Model Creation */

+ (WTDDataModel_v1 *)insertedPopulatedModelWithName:(NSString *)name inManagedObjectContext:(NSManagedObjectContext *)managedObjectContext;

+ (WTDDataModel_v1 *)insertedModelWithName:(NSString *)name inManagedObjectContext:(NSManagedObjectContext *)managedObjectContext;


/* Models */

+ (WTDDataModel_v1 *)modelWithName:(NSString *)name inManagedObjectContext:(NSManagedObjectContext *)managedObjectContext;


+ (NSArray *)allModelsInManagedObjectContext:(NSManagedObjectContext *)managedObjectContext;

+ (NSArray *)allModelsWithName:(NSString *)name inManagedObjectContext:(NSManagedObjectContext *)managedObjectContext;

+ (WTDDataModel_v1 *)modelWithUUID:(NSString *)uuid inManagedObjectContext:(NSManagedObjectContext *)managedObjectContext;


/* Contexts */

- (WTDContext_v1 *) addContextWithName: (NSString *) name;
- (void) removeContextWithName: (NSString *) name;

- (WTDContext_v1 *) contextWithName: (NSString *) name;


- (NSArray *) contextNames;

/* Import/Export */

- (BOOL) importFromPropertyList:(id)propertyList;

- (WTDToDoItem_v1 *) importedRootToDoItemFromPropertyList:(id)propertyList;


- (id) propertyListForExport;


- (BOOL) isToDoItemLocal:(WTDToDoItem_v1 *)toDoItem;

- (void)mergeContexts;

- (void)mergeWithModel:(WTDDataModel_v1 *)model;


+ (unsigned int)countOfToDoItemsAndDescendentsInArray:(NSArray *)toDoItemArray;

@end
